Merge remote-tracking branch 'origin/stable-2.0'
[bpt/guile.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27 $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35 && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64 $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70 $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73 prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec. The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks. ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with `sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131 $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139 @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148 @echo $(patsubst sc_%.m, %, $@)
149 @date +%s.%N > .sc-start-$(basename $@)
150
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153 .PHONY: $(sc_z_rules_)
154 $(sc_z_rules_): %.z: %
155 @end=$$(date +%s.%N); \
156 start=$$(cat .sc-start-$*); \
157 rm -f .sc-start-$*; \
158 awk -v s=$$start -v e=$$end \
159 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
163 local-check := \
164 $(patsubst sc_%, sc_%.z, \
165 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167 syntax-check: $(local-check)
168
169 # _sc_search_regexp
170 #
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
173 #
174 # Parameters (shell variables):
175 #
176 # prohibit | require
177 #
178 # Regular expression (ERE) denoting either a forbidden construct
179 # or a required construct. Those arguments are exclusive.
180 #
181 # in_vc_files | in_files
182 #
183 # grep-E-style regexp denoting the files to check. If no files
184 # are specified the default are all the files that are under
185 # version control.
186 #
187 # containing | non_containing
188 #
189 # Select the files (non) containing strings matching this regexp.
190 # If both arguments are specified then CONTAINING takes
191 # precedence.
192 #
193 # with_grep_options
194 #
195 # Extra options for grep.
196 #
197 # ignore_case
198 #
199 # Ignore case.
200 #
201 # halt
202 #
203 # Message to display before to halting execution.
204 #
205 # Finally, you may exempt files based on an ERE matching file names.
206 # For example, to exempt from the sc_space_tab check all files with the
207 # .diff suffix, set this Make variable:
208 #
209 # exclude_file_name_regexp--sc_space_tab = \.diff$
210 #
211 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
212 # when filtering by name via in_files, we explicitly filter out matching
213 # names here as well.
214
215 # By default, _sc_search_regexp does not ignore case.
216 export ignore_case =
217 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
218
219 define _sc_say_and_exit
220 dummy=; : so we do not need a semicolon before each use; \
221 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
222 endef
223
224 # _sc_search_regexp used to be named _prohibit_regexp. However,
225 # upgrading to the new definition and leaving the old name undefined
226 # would usually convert each custom rule using $(_prohibit_regexp)
227 # (usually defined in cfg.mk) into a no-op. This definition ensures
228 # that people know right away if they're still using the old name.
229 # FIXME: remove in 2012.
230 _prohibit_regexp = \
231 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
232
233 define _sc_search_regexp
234 dummy=; : so we do not need a semicolon before each use; \
235 \
236 : Check arguments; \
237 test -n "$$prohibit" && test -n "$$require" \
238 && { msg='Cannot specify both prohibit and require' \
239 $(_sc_say_and_exit) } || :; \
240 test -z "$$prohibit" && test -z "$$require" \
241 && { msg='Should specify either prohibit or require' \
242 $(_sc_say_and_exit) } || :; \
243 test -n "$$in_vc_files" && test -n "$$in_files" \
244 && { msg='Cannot specify both in_vc_files and in_files' \
245 $(_sc_say_and_exit) } || :; \
246 test "x$$halt" != x \
247 || { msg='halt not defined' $(_sc_say_and_exit) }; \
248 \
249 : Filter by file name; \
250 if test -n "$$in_files"; then \
251 files=$$(find $(srcdir) | grep -E "$$in_files" \
252 | grep -Ev '$(exclude_file_name_regexp--$@)'); \
253 else \
254 files=$$($(VC_LIST_EXCEPT)); \
255 if test -n "$$in_vc_files"; then \
256 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
257 fi; \
258 fi; \
259 \
260 : Filter by content; \
261 test -n "$$files" && test -n "$$containing" \
262 && { files=$$(grep -l "$$containing" $$files); } || :; \
263 test -n "$$files" && test -n "$$non_containing" \
264 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
265 \
266 : Check for the construct; \
267 if test -n "$$files"; then \
268 if test -n "$$prohibit"; then \
269 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
270 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
271 else \
272 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
273 | grep . \
274 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
275 fi \
276 else :; \
277 fi || :;
278 endef
279
280 sc_avoid_if_before_free:
281 @$(srcdir)/$(_build-aux)/useless-if-before-free \
282 $(useless_free_options) \
283 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
284 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
285 exit 1; } || :
286
287 sc_cast_of_argument_to_free:
288 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
289 $(_sc_search_regexp)
290
291 sc_cast_of_x_alloc_return_value:
292 @prohibit='\*\) *x(m|c|re)alloc\>' \
293 halt='don'\''t cast x*alloc return value' \
294 $(_sc_search_regexp)
295
296 sc_cast_of_alloca_return_value:
297 @prohibit='\*\) *alloca\>' \
298 halt='don'\''t cast alloca return value' \
299 $(_sc_search_regexp)
300
301 sc_space_tab:
302 @prohibit='[ ] ' \
303 halt='found SPACE-TAB sequence; remove the SPACE' \
304 $(_sc_search_regexp)
305
306 # Don't use *scanf or the old ato* functions in `real' code.
307 # They provide no error checking mechanism.
308 # Instead, use strto* functions.
309 sc_prohibit_atoi_atof:
310 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
311 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
312 $(_sc_search_regexp)
313
314 # Use STREQ rather than comparing strcmp == 0, or != 0.
315 sc_prohibit_strcmp:
316 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
317 $$($(VC_LIST_EXCEPT)) \
318 | grep -vE ':# *define STRN?EQ\(' && \
319 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
320 1>&2; exit 1; } || :
321
322 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
323 # Convert all uses automatically, via these two commands:
324 # git grep -l '\<exit *(1)' \
325 # | grep -vEf .x-sc_prohibit_magic_number_exit \
326 # | xargs --no-run-if-empty \
327 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
328 # git grep -l '\<exit *(0)' \
329 # | grep -vEf .x-sc_prohibit_magic_number_exit \
330 # | xargs --no-run-if-empty \
331 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
332 sc_prohibit_magic_number_exit:
333 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
334 halt='use EXIT_* values rather than magic number' \
335 $(_sc_search_regexp)
336
337 # Using EXIT_SUCCESS as the first argument to error is misleading,
338 # since when that parameter is 0, error does not exit. Use `0' instead.
339 sc_error_exit_success:
340 @prohibit='error *\(EXIT_SUCCESS,' \
341 in_vc_files='\.[chly]$$' \
342 halt='found error (EXIT_SUCCESS' \
343 $(_sc_search_regexp)
344
345 # `FATAL:' should be fully upper-cased in error messages
346 # `WARNING:' should be fully upper-cased, or fully lower-cased
347 sc_error_message_warn_fatal:
348 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
349 | grep -E '"Warning|"Fatal|"fatal' && \
350 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
351 exit 1; } || :
352
353 # Error messages should not start with a capital letter
354 sc_error_message_uppercase:
355 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
356 | grep -E '"[A-Z]' \
357 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
358 { echo '$(ME): found capitalized error message' 1>&2; \
359 exit 1; } || :
360
361 # Error messages should not end with a period
362 sc_error_message_period:
363 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
364 | grep -E '[^."]\."' && \
365 { echo '$(ME): found error message ending in period' 1>&2; \
366 exit 1; } || :
367
368 sc_file_system:
369 @prohibit=file''system \
370 ignore_case=1 \
371 halt='found use of "file''system"; spell it "file system"' \
372 $(_sc_search_regexp)
373
374 # Don't use cpp tests of this symbol. All code assumes config.h is included.
375 sc_prohibit_have_config_h:
376 @prohibit='^# *if.*HAVE''_CONFIG_H' \
377 halt='found use of HAVE''_CONFIG_H; remove' \
378 $(_sc_search_regexp)
379
380 # Nearly all .c files must include <config.h>. However, we also permit this
381 # via inclusion of a package-specific header, if cfg.mk specified one.
382 # config_h_header must be suitable for grep -E.
383 config_h_header ?= <config\.h>
384 sc_require_config_h:
385 @require='^# *include $(config_h_header)' \
386 in_vc_files='\.c$$' \
387 halt='the above files do not include <config.h>' \
388 $(_sc_search_regexp)
389
390 # You must include <config.h> before including any other header file.
391 # This can possibly be via a package-specific header, if given by cfg.mk.
392 sc_require_config_h_first:
393 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
394 fail=0; \
395 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
396 grep '^# *include\>' $$i | sed 1q \
397 | grep -E '^# *include $(config_h_header)' > /dev/null \
398 || { echo $$i; fail=1; }; \
399 done; \
400 test $$fail = 1 && \
401 { echo '$(ME): the above files include some other header' \
402 'before <config.h>' 1>&2; exit 1; } || :; \
403 else :; \
404 fi
405
406 sc_prohibit_HAVE_MBRTOWC:
407 @prohibit='\bHAVE_MBRTOWC\b' \
408 halt="do not use $$prohibit; it is always defined" \
409 $(_sc_search_regexp)
410
411 # To use this "command" macro, you must first define two shell variables:
412 # h: the header name, with no enclosing <> or ""
413 # re: a regular expression that matches IFF something provided by $h is used.
414 define _sc_header_without_use
415 dummy=; : so we do not need a semicolon before each use; \
416 h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
417 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
418 files=$$(grep -l '^# *include '"$$h_esc" \
419 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
420 grep -LE "$$re" $$files | grep . && \
421 { echo "$(ME): the above files include $$h but don't use it" \
422 1>&2; exit 1; } || :; \
423 else :; \
424 fi
425 endef
426
427 # Prohibit the inclusion of assert.h without an actual use of assert.
428 sc_prohibit_assert_without_use:
429 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
430
431 # Prohibit the inclusion of close-stream.h without an actual use.
432 sc_prohibit_close_stream_without_use:
433 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
434
435 # Prohibit the inclusion of getopt.h without an actual use.
436 sc_prohibit_getopt_without_use:
437 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
438
439 # Don't include quotearg.h unless you use one of its functions.
440 sc_prohibit_quotearg_without_use:
441 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
442
443 # Don't include quote.h unless you use one of its functions.
444 sc_prohibit_quote_without_use:
445 @h='quote.h' re='\<quote(_n)? *\(' $(_sc_header_without_use)
446
447 # Don't include this header unless you use one of its functions.
448 sc_prohibit_long_options_without_use:
449 @h='long-options.h' re='\<parse_long_options *\(' \
450 $(_sc_header_without_use)
451
452 # Don't include this header unless you use one of its functions.
453 sc_prohibit_inttostr_without_use:
454 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
455 $(_sc_header_without_use)
456
457 # Don't include this header unless you use one of its functions.
458 sc_prohibit_ignore_value_without_use:
459 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
460 $(_sc_header_without_use)
461
462 # Don't include this header unless you use one of its functions.
463 sc_prohibit_error_without_use:
464 @h='error.h' \
465 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
466 $(_sc_header_without_use)
467
468 # Don't include xalloc.h unless you use one of its functions.
469 # Consider these symbols:
470 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
471 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
472 # Divide into two sets on case, and filter each through this:
473 # | sort | perl -MRegexp::Assemble -le \
474 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
475 # Note this was produced by the above:
476 # _xa1 = \
477 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
478 # But we can do better, in at least two ways:
479 # 1) take advantage of two "dup"-suffixed strings:
480 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
481 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
482 # "char|[cmz]"
483 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
484 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
485 _xa2 = X([CZ]|N?M)ALLOC
486 sc_prohibit_xalloc_without_use:
487 @h='xalloc.h' \
488 re='\<($(_xa1)|$(_xa2)) *\('\
489 $(_sc_header_without_use)
490
491 # Extract function names:
492 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
493 _hash_re = \
494 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
495 _hash_fn = \<($(_hash_re)) *\(
496 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
497 sc_prohibit_hash_without_use:
498 @h='hash.h' \
499 re='$(_hash_fn)|$(_hash_struct)'\
500 $(_sc_header_without_use)
501
502 sc_prohibit_cloexec_without_use:
503 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
504 $(_sc_header_without_use)
505
506 sc_prohibit_posixver_without_use:
507 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
508
509 sc_prohibit_same_without_use:
510 @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
511
512 sc_prohibit_hash_pjw_without_use:
513 @h='hash-pjw.h' \
514 re='\<hash_pjw *\(' \
515 $(_sc_header_without_use)
516
517 sc_prohibit_safe_read_without_use:
518 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
519 $(_sc_header_without_use)
520
521 sc_prohibit_argmatch_without_use:
522 @h='argmatch.h' \
523 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
524 $(_sc_header_without_use)
525
526 sc_prohibit_canonicalize_without_use:
527 @h='canonicalize.h' \
528 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
529 $(_sc_header_without_use)
530
531 sc_prohibit_root_dev_ino_without_use:
532 @h='root-dev-ino.h' \
533 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
534 $(_sc_header_without_use)
535
536 sc_prohibit_openat_without_use:
537 @h='openat.h' \
538 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
539 $(_sc_header_without_use)
540
541 # Prohibit the inclusion of c-ctype.h without an actual use.
542 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
543 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
544 sc_prohibit_c_ctype_without_use:
545 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
546 $(_sc_header_without_use)
547
548 _empty =
549 _sp = $(_empty) $(_empty)
550 # The following list was generated by running:
551 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
552 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
553 _sig_functions = \
554 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
555 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
556 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
557 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
558 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
559 # The following were extracted from "man signal.h" manually.
560 _sig_types_and_consts = \
561 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
562 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
563 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
564 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
565 sigstack sigval stack_t ucontext_t
566 # generated via this:
567 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
568 _sig_names = \
569 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
570 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
571 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
572 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
573 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
574 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
575 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
576 SIGXCPU SIGXFSZ
577 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
578
579 # Prohibit the inclusion of signal.h without an actual use.
580 sc_prohibit_signal_without_use:
581 @h='signal.h' \
582 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
583 $(_sc_header_without_use)
584
585 # Don't include stdio--.h unless you use one of its functions.
586 sc_prohibit_stdio--_without_use:
587 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
588 $(_sc_header_without_use)
589
590 # Don't include stdio-safer.h unless you use one of its functions.
591 sc_prohibit_stdio-safer_without_use:
592 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
593 $(_sc_header_without_use)
594
595 # Prohibit the inclusion of strings.h without a sensible use.
596 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
597 sc_prohibit_strings_without_use:
598 @h='strings.h' \
599 re='\<(strn?casecmp|ffs(ll)?)\>' \
600 $(_sc_header_without_use)
601
602 # Get the list of symbol names with this:
603 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
604 _intprops_names = \
605 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
606 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
607 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
608 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
609 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
610 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
611 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
612 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
613 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
614 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
615 # Prohibit the inclusion of intprops.h without an actual use.
616 sc_prohibit_intprops_without_use:
617 @h='intprops.h' \
618 re='\<($(_intprops_syms_re)) *\(' \
619 $(_sc_header_without_use)
620
621 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
622 # Prohibit the inclusion of stddef.h without an actual use.
623 sc_prohibit_stddef_without_use:
624 @h='stddef.h' \
625 re='\<($(_stddef_syms_re))\>' \
626 $(_sc_header_without_use)
627
628 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
629 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
630 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
631 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
632 # Prohibit the inclusion of dirent.h without an actual use.
633 sc_prohibit_dirent_without_use:
634 @h='dirent.h' \
635 re='\<($(_dirent_syms_re))\>' \
636 $(_sc_header_without_use)
637
638 # Prohibit the inclusion of verify.h without an actual use.
639 sc_prohibit_verify_without_use:
640 @h='verify.h' \
641 re='\<(verify(true|expr)?|static_assert) *\(' \
642 $(_sc_header_without_use)
643
644 # Don't include xfreopen.h unless you use one of its functions.
645 sc_prohibit_xfreopen_without_use:
646 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
647
648 sc_obsolete_symbols:
649 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
650 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
651 $(_sc_search_regexp)
652
653 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
654
655 # Each nonempty ChangeLog line must start with a year number, or a TAB.
656 sc_changelog:
657 @prohibit='^[^12 ]' \
658 in_vc_files='^ChangeLog$$' \
659 halt='found unexpected prefix in a ChangeLog' \
660 $(_sc_search_regexp)
661
662 # Ensure that each .c file containing a "main" function also
663 # calls set_program_name.
664 sc_program_name:
665 @require='set_program_name *\(m?argv\[0\]\);' \
666 in_vc_files='\.c$$' \
667 containing='\<main *(' \
668 halt='the above files do not call set_program_name' \
669 $(_sc_search_regexp)
670
671 # Ensure that each .c file containing a "main" function also
672 # calls bindtextdomain.
673 sc_bindtextdomain:
674 @require='bindtextdomain *\(' \
675 in_vc_files='\.c$$' \
676 containing='\<main *(' \
677 halt='the above files do not call bindtextdomain' \
678 $(_sc_search_regexp)
679
680 # Require that the final line of each test-lib.sh-using test be this one:
681 # Exit $fail
682 # Note: this test requires GNU grep's --label= option.
683 Exit_witness_file ?= tests/test-lib.sh
684 Exit_base := $(notdir $(Exit_witness_file))
685 sc_require_test_exit_idiom:
686 @if test -f $(srcdir)/$(Exit_witness_file); then \
687 die=0; \
688 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
689 $$($(VC_LIST) tests)); do \
690 tail -n1 $$i | grep '^Exit .' > /dev/null \
691 && : || { die=1; echo $$i; } \
692 done; \
693 test $$die = 1 && \
694 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
695 echo 1>&2 'Exit something'; \
696 exit 1; } || :; \
697 fi
698
699 sc_trailing_blank:
700 @prohibit='[ ]$$' \
701 halt='found trailing blank(s)' \
702 $(_sc_search_regexp)
703
704 # Match lines like the following, but where there is only one space
705 # between the options and the description:
706 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
707 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
708 sc_two_space_separator_in_usage:
709 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
710 halt='help2man requires at least two spaces between an option and its description'\
711 $(_sc_search_regexp)
712
713 # A regexp matching function names like "error" that may be used
714 # to emit translatable messages.
715 _gl_translatable_diag_func_re ?= error
716
717 # Look for diagnostics that aren't marked for translation.
718 # This won't find any for which error's format string is on a separate line.
719 sc_unmarked_diagnostics:
720 @grep -nE \
721 '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
722 $$($(VC_LIST_EXCEPT)) \
723 | grep -Ev '(_|ngettext ?)\(' && \
724 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
725 exit 1; } || :
726
727 # Avoid useless parentheses like those in this example:
728 # #if defined (SYMBOL) || defined (SYM2)
729 sc_useless_cpp_parens:
730 @prohibit='^# *if .*defined *\(' \
731 halt='found useless parentheses in cpp directive' \
732 $(_sc_search_regexp)
733
734 # List headers for which HAVE_HEADER_H is always true, assuming you are
735 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
736 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
737 # requires the gnulib module that guarantees the usability of that header.
738 gl_assured_headers_ = \
739 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
740
741 # Convert the list of names to upper case, and replace each space with "|".
742 az_ = abcdefghijklmnopqrstuvwxyz
743 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
744 gl_header_upper_case_or_ = \
745 $$($(gl_assured_headers_) \
746 | tr $(az_)/.- $(AZ_)___ \
747 | tr -s ' ' '|' \
748 )
749 sc_prohibit_always_true_header_tests:
750 @or=$(gl_header_upper_case_or_); \
751 re="HAVE_($$or)_H"; \
752 prohibit='\<'"$$re"'\>' \
753 halt=$$(printf '%s\n' \
754 'do not test the above HAVE_<header>_H symbol(s);' \
755 ' with the corresponding gnulib module, they are always true') \
756 $(_sc_search_regexp)
757
758 # ==================================================================
759 gl_other_headers_ ?= \
760 intprops.h \
761 openat.h \
762 stat-macros.h
763
764 # Perl -lne code to extract "significant" cpp-defined symbols from a
765 # gnulib header file, eliminating a few common false-positives.
766 # The exempted names below are defined only conditionally in gnulib,
767 # and hence sometimes must/may be defined in application code.
768 gl_extract_significant_defines_ = \
769 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
770 && $$2 !~ /(?:rpl_|_used_without_)/\
771 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
772 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
773 and print $$1
774
775 # Create a list of regular expressions matching the names
776 # of macros that are guaranteed to be defined by parts of gnulib.
777 define def_sym_regex
778 gen_h=$(gl_generated_headers_); \
779 (cd $(gnulib_dir)/lib; \
780 for f in *.in.h $(gl_other_headers_); do \
781 test -f $$f \
782 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
783 done; \
784 ) | sort -u \
785 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
786 endef
787
788 # Don't define macros that we already get from gnulib header files.
789 sc_prohibit_always-defined_macros:
790 @if test -d $(gnulib_dir); then \
791 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
792 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
793 esac; \
794 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
795 && { echo '$(ME): define the above via some gnulib .h file' \
796 1>&2; exit 1; } || :; \
797 fi
798 # ==================================================================
799
800 # Prohibit checked in backup files.
801 sc_prohibit_backup_files:
802 @$(VC_LIST) | grep '~$$' && \
803 { echo '$(ME): found version controlled backup file' 1>&2; \
804 exit 1; } || :
805
806 # Require the latest GPL.
807 sc_GPL_version:
808 @prohibit='either ''version [^3]' \
809 halt='GPL vN, N!=3' \
810 $(_sc_search_regexp)
811
812 # Require the latest GFDL. Two regexp, since some .texi files end up
813 # line wrapping between 'Free Documentation License,' and 'Version'.
814 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
815 sc_GFDL_version:
816 @prohibit='$(_GFDL_regexp)' \
817 halt='GFDL vN, N!=3' \
818 $(_sc_search_regexp)
819
820 # Don't use Texinfo's @acronym{}.
821 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
822 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
823 sc_texinfo_acronym:
824 @prohibit='@acronym\{' \
825 in_vc_files='$(texinfo_suffix_re_)' \
826 halt='found use of Texinfo @acronym{}' \
827 $(_sc_search_regexp)
828
829 cvs_keywords = \
830 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
831
832 sc_prohibit_cvs_keyword:
833 @prohibit='\$$($(cvs_keywords))\$$' \
834 halt='do not use CVS keyword expansion' \
835 $(_sc_search_regexp)
836
837 # This Perl code is slightly obfuscated. Not only is each "$" doubled
838 # because it's in a Makefile, but the $$c's are comments; we cannot
839 # use "#" due to the way the script ends up concatenated onto one line.
840 # It would be much more concise, and would produce better output (including
841 # counts) if written as:
842 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
843 # but that would be far less efficient, reading the entire contents
844 # of each file, rather than just the last two bytes of each.
845 # In addition, while the code below detects both blank lines and a missing
846 # newline at EOF, the above detects only the former.
847 #
848 # This is a perl script that is expected to be the single-quoted argument
849 # to a command-line "-le". The remaining arguments are file names.
850 # Print the name of each file that ends in exactly one newline byte.
851 # I.e., warn if there are blank lines (2 or more newlines), or if the
852 # last byte is not a newline. However, currently we don't complain
853 # about any file that contains exactly one byte.
854 # Exit nonzero if at least one such file is found, otherwise, exit 0.
855 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
856 #
857 # Use this if you want to remove trailing empty lines from selected files:
858 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
859 #
860 require_exactly_one_NL_at_EOF_ = \
861 foreach my $$f (@ARGV) \
862 { \
863 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
864 my $$p = sysseek (F, -2, 2); \
865 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
866 my $$last_two_bytes; \
867 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
868 close F; \
869 $$c = "ignore read failure"; \
870 $$p && ($$last_two_bytes eq "\n\n" \
871 || substr ($$last_two_bytes,1) ne "\n") \
872 and (print $$f), $$fail=1; \
873 } \
874 END { exit defined $$fail }
875 sc_prohibit_empty_lines_at_EOF:
876 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
877 || { echo '$(ME): empty line(s) or no newline at EOF' \
878 1>&2; exit 1; } || :
879
880 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
881 # This is a bit of a kludge, since it prevents use of the string
882 # even in comments, but for now it does the job with no false positives.
883 sc_prohibit_stat_st_blocks:
884 @prohibit='[.>]st_blocks' \
885 halt='do not use st_blocks; use ST_NBLOCKS' \
886 $(_sc_search_regexp)
887
888 # Make sure we don't define any S_IS* macros in src/*.c files.
889 # They're already defined via gnulib's sys/stat.h replacement.
890 sc_prohibit_S_IS_definition:
891 @prohibit='^ *# *define *S_IS' \
892 halt='do not define S_IS* macros; include <sys/stat.h>' \
893 $(_sc_search_regexp)
894
895 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
896 # that is shared by two definitions below.
897 perl_filename_lineno_text_ = \
898 -e ' {' \
899 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
900 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
901 -e ' print "$$ARGV:$$n:$$v\n";' \
902 -e ' }'
903
904 prohibit_doubled_word_RE_ ?= \
905 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
906 prohibit_doubled_word_ = \
907 -e 'while ($(prohibit_doubled_word_RE_))' \
908 $(perl_filename_lineno_text_)
909
910 # Define this to a regular expression that matches
911 # any filename:dd:match lines you want to ignore.
912 # The default is to ignore no matches.
913 ignore_doubled_word_match_RE_ ?= ^$$
914
915 sc_prohibit_doubled_word:
916 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
917 | grep -vE '$(ignore_doubled_word_match_RE_)' \
918 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
919
920 # A regular expression matching undesirable combinations of words like
921 # "can not"; this matches them even when the two words appear on different
922 # lines, but not when there is an intervening delimiter like "#" or "*".
923 prohibit_undesirable_word_seq_RE_ ?= \
924 /\bcan\s+not\b/gims
925 prohibit_undesirable_word_seq_ = \
926 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
927 $(perl_filename_lineno_text_)
928 # Define this to a regular expression that matches
929 # any filename:dd:match lines you want to ignore.
930 # The default is to ignore no matches.
931 ignore_undesirable_word_sequence_RE_ ?= ^$$
932
933 sc_prohibit_undesirable_word_seq:
934 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
935 $$($(VC_LIST_EXCEPT)) \
936 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
937 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
938
939 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
940 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
941 # Using test's -a and -o operators is not portable.
942 # We prefer test over [, since the latter is spelled [[ in configure.ac.
943 sc_prohibit_test_minus_ao:
944 @prohibit='(\<test| \[+) .+ -[ao] ' \
945 halt='$(_ptm1); $(_ptm2)' \
946 $(_sc_search_regexp)
947
948 # Avoid a test bashism.
949 sc_prohibit_test_double_equal:
950 @prohibit='(\<test| \[+) .+ == ' \
951 containing='#! */bin/[a-z]*sh' \
952 halt='use "test x = x", not "test x =''= x"' \
953 $(_sc_search_regexp)
954
955 # Each program that uses proper_name_utf8 must link with one of the
956 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
957 # The perl -0777 invocation below extracts the possibly-multi-line
958 # definition of LDADD from the appropriate Makefile.am and exits 0
959 # when it contains "ICONV".
960 sc_proper_name_utf8_requires_ICONV:
961 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
962 if test "x$$progs" != x; then \
963 fail=0; \
964 for p in $$progs; do \
965 dir=$$(dirname "$$p"); \
966 perl -0777 \
967 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
968 $$dir/Makefile.am && continue; \
969 base=$$(basename "$$p" .c); \
970 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
971 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
972 done; \
973 test $$fail = 1 && \
974 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
975 exit 1; } || :; \
976 fi
977
978 # Warn about "c0nst struct Foo const foo[]",
979 # but not about "char const *const foo" or "#define const const".
980 sc_redundant_const:
981 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
982 halt='redundant "const" in declarations' \
983 $(_sc_search_regexp)
984
985 sc_const_long_option:
986 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
987 | grep -Ev 'const struct option|struct option const' && { \
988 echo 1>&2 '$(ME): add "const" to the above declarations'; \
989 exit 1; } || :
990
991 NEWS_hash = \
992 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
993 $(srcdir)/NEWS \
994 | perl -0777 -pe \
995 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
996 | md5sum - \
997 | sed 's/ .*//')
998
999 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1000 sc_immutable_NEWS:
1001 @if test -f $(srcdir)/NEWS; then \
1002 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1003 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1004 fi
1005
1006 # Update the hash stored above. Do this after each release and
1007 # for any corrections to old entries.
1008 update-NEWS-hash: NEWS
1009 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1010 $(srcdir)/cfg.mk
1011
1012 # Ensure that we use only the standard $(VAR) notation,
1013 # not @...@ in Makefile.am, now that we can rely on automake
1014 # to emit a definition for each substituted variable.
1015 # However, there is still one case in which @VAR@ use is not just
1016 # legitimate, but actually required: when augmenting an automake-defined
1017 # variable with a prefix. For example, gettext uses this:
1018 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1019 # otherwise, makeinfo would put German or French (current locale)
1020 # navigation hints in the otherwise-English documentation.
1021 #
1022 # Allow the package to add exceptions via a hook in cfg.mk;
1023 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1024 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1025 _makefile_at_at_check_exceptions ?=
1026 sc_makefile_at_at_check:
1027 @perl -ne '/\@[A-Z_0-9]+\@/' \
1028 -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/' \
1029 -e ''$(_makefile_at_at_check_exceptions) \
1030 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1031 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1032 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1033
1034 news-check: NEWS
1035 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
1036 | grep -E $(news-check-regexp) >/dev/null; then \
1037 :; \
1038 else \
1039 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1040 exit 1; \
1041 fi
1042
1043 sc_makefile_TAB_only_indentation:
1044 @prohibit='^ [ ]{8}' \
1045 in_vc_files='akefile|\.mk$$' \
1046 halt='found TAB-8-space indentation' \
1047 $(_sc_search_regexp)
1048
1049 sc_m4_quote_check:
1050 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1051 in_vc_files='(^configure\.ac|\.m4)$$' \
1052 halt='quote the first arg to AC_DEF*' \
1053 $(_sc_search_regexp)
1054
1055 fix_po_file_diag = \
1056 'you have changed the set of files with translatable diagnostics;\n\
1057 apply the above patch\n'
1058
1059 # Verify that all source files using _() are listed in po/POTFILES.in.
1060 po_file ?= $(srcdir)/po/POTFILES.in
1061 generated_files ?= $(srcdir)/lib/*.[ch]
1062 sc_po_check:
1063 @if test -f $(po_file); then \
1064 grep -E -v '^(#|$$)' $(po_file) \
1065 | grep -v '^src/false\.c$$' | sort > $@-1; \
1066 files=; \
1067 for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
1068 test -r $$file || continue; \
1069 case $$file in \
1070 *.m4|*.mk) continue ;; \
1071 *.?|*.??) ;; \
1072 *) continue;; \
1073 esac; \
1074 case $$file in \
1075 *.[ch]) \
1076 base=`expr " $$file" : ' \(.*\)\..'`; \
1077 { test -f $$base.l || test -f $$base.y; } && continue;; \
1078 esac; \
1079 files="$$files $$file"; \
1080 done; \
1081 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
1082 | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
1083 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1084 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1085 rm -f $@-1 $@-2; \
1086 fi
1087
1088 # Sometimes it is useful to change the PATH environment variable
1089 # in Makefiles. When doing so, it's better not to use the Unix-centric
1090 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1091 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1092 sc_makefile_path_separator_check:
1093 @prohibit='PATH[=].*:' \
1094 in_vc_files='akefile|\.mk$$' \
1095 halt=$(msg) \
1096 $(_sc_search_regexp)
1097
1098 # Check that `make alpha' will not fail at the end of the process,
1099 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1100 # and is read-only.
1101 writable-files:
1102 if test -d $(release_archive_dir); then \
1103 for file in $(DIST_ARCHIVES); do \
1104 for p in ./ $(release_archive_dir)/; do \
1105 test -e $$p$$file || continue; \
1106 test -w $$p$$file \
1107 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1108 done; \
1109 done; \
1110 test "$$fail" && exit 1 || : ; \
1111 else :; \
1112 fi
1113
1114 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1115 sample-test = tests/sample-test
1116 texi = doc/$(PACKAGE).texi
1117 # Make sure that the copyright date in $(v_etc_file) is up to date.
1118 # Do the same for the $(sample-test) and the main doc/.texi file.
1119 sc_copyright_check:
1120 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1121 in_files=$(v_etc_file) \
1122 halt='out of date copyright in $(v_etc_file); update it' \
1123 $(_sc_search_regexp)
1124 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1125 in_vc_files=$(sample-test) \
1126 halt='out of date copyright in $(sample-test); update it' \
1127 $(_sc_search_regexp)
1128 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1129 in_vc_files=$(texi) \
1130 halt='out of date copyright in $(texi); update it' \
1131 $(_sc_search_regexp)
1132
1133 # If tests/help-version exists and seems to be new enough, assume that its
1134 # use of init.sh and path_prepend_ is correct, and ensure that every other
1135 # use of init.sh is identical.
1136 # This is useful because help-version cross-checks prog --version
1137 # with $(VERSION), which verifies that its path_prepend_ invocation
1138 # sets PATH correctly. This is an inexpensive way to ensure that
1139 # the other init.sh-using tests also get it right.
1140 _hv_file ?= $(srcdir)/tests/help-version
1141 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1142 # Fix syntax-highlighters "
1143 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1144 sc_cross_check_PATH_usage_in_tests:
1145 @if test -f $(_hv_file); then \
1146 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1147 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1148 exit 0; }; \
1149 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1150 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1151 exit 1; }; \
1152 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1153 grep -LFx "$$good" \
1154 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1155 | grep . && \
1156 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1157 1>&2; exit 1; } || :; \
1158 fi
1159
1160 # BRE regex of file contents to identify a test script.
1161 _test_script_regex ?= \<init\.sh\>
1162
1163 # In tests, use "compare expected actual", not the reverse.
1164 sc_prohibit_reversed_compare_failure:
1165 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1166 containing='$(_test_script_regex)' \
1167 halt='reversed compare arguments' \
1168 $(_sc_search_regexp)
1169
1170 # #if HAVE_... will evaluate to false for any non numeric string.
1171 # That would be flagged by using -Wundef, however gnulib currently
1172 # tests many undefined macros, and so we can't enable that option.
1173 # So at least preclude common boolean strings as macro values.
1174 sc_Wundef_boolean:
1175 @prohibit='^#define.*(yes|no|true|false)$$' \
1176 in_files='$(CONFIG_INCLUDE)' \
1177 halt='Use 0 or 1 for macro values' \
1178 $(_sc_search_regexp)
1179
1180 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1181 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1182 # a limit, not an array or alloca size.
1183 sc_prohibit_path_max_allocation:
1184 @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
1185 halt='Avoid stack allocations of size PATH_MAX' \
1186 $(_sc_search_regexp)
1187
1188 sc_vulnerable_makefile_CVE-2009-4029:
1189 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1190 in_files=$$(find $(srcdir) -name Makefile.in) \
1191 halt=$$(printf '%s\n' \
1192 'the above files are vulnerable; beware of running' \
1193 ' "make dist*" rules, and upgrade to fixed automake' \
1194 ' see http://bugzilla.redhat.com/542609 for details') \
1195 $(_sc_search_regexp)
1196
1197 vc-diff-check:
1198 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1199 if test -s vc-diffs; then \
1200 cat vc-diffs; \
1201 echo "Some files are locally modified:" 1>&2; \
1202 exit 1; \
1203 else \
1204 rm vc-diffs; \
1205 fi
1206
1207 rel-files = $(DIST_ARCHIVES)
1208
1209 gnulib_dir ?= $(srcdir)/gnulib
1210 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1211 bootstrap-tools ?= autoconf,automake,gnulib
1212
1213 # If it's not already specified, derive the GPG key ID from
1214 # the signed tag we've just applied to mark this release.
1215 gpg_key_ID ?= \
1216 $$(git cat-file tag v$(VERSION) \
1217 | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1218 | sed -n '/^\[GNUPG:\] ERRSIG /{s///;s/ .*//p;q}')
1219
1220 translation_project_ ?= coordinator@translationproject.org
1221
1222 # Make info-gnu the default only for a stable release.
1223 ifeq ($(RELEASE_TYPE),stable)
1224 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1225 announcement_mail_headers_ ?= \
1226 To: info-gnu@gnu.org \
1227 Cc: $(announcement_Cc_) \
1228 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1229 else
1230 announcement_Cc_ ?= $(translation_project_)
1231 announcement_mail_headers_ ?= \
1232 To: $(PACKAGE_BUGREPORT) \
1233 Cc: $(announcement_Cc_)
1234 endif
1235
1236 announcement: NEWS ChangeLog $(rel-files)
1237 @$(srcdir)/$(_build-aux)/announce-gen \
1238 --mail-headers='$(announcement_mail_headers_)' \
1239 --release-type=$(RELEASE_TYPE) \
1240 --package=$(PACKAGE) \
1241 --prev=$(PREV_VERSION) \
1242 --curr=$(VERSION) \
1243 --gpg-key-id=$(gpg_key_ID) \
1244 --news=$(srcdir)/NEWS \
1245 --bootstrap-tools=$(bootstrap-tools) \
1246 --gnulib-version=$(gnulib-version) \
1247 --no-print-checksums \
1248 $(addprefix --url-dir=, $(url_dir_list))
1249
1250 ## ---------------- ##
1251 ## Updating files. ##
1252 ## ---------------- ##
1253
1254 ftp-gnu = ftp://ftp.gnu.org/gnu
1255 www-gnu = http://www.gnu.org
1256
1257 upload_dest_dir_ ?= $(PACKAGE)
1258 emit_upload_commands:
1259 @echo =====================================
1260 @echo =====================================
1261 @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1262 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1263 @echo " $(rel-files)"
1264 @echo '# send the ~/announce-$(my_distdir) e-mail'
1265 @echo =====================================
1266 @echo =====================================
1267
1268 define emit-commit-log
1269 printf '%s\n' 'maint: post-release administrivia' '' \
1270 '* NEWS: Add header line for next release.' \
1271 '* .prev-version: Record previous version.' \
1272 '* cfg.mk (old_NEWS_hash): Auto-update.'
1273 endef
1274
1275 .PHONY: no-submodule-changes
1276 no-submodule-changes:
1277 if test -d $(srcdir)/.git; then \
1278 diff=$$(cd $(srcdir) && git submodule -q foreach \
1279 git diff-index --name-only HEAD) \
1280 || exit 1; \
1281 case $$diff in '') ;; \
1282 *) echo '$(ME): submodule files are locally modified:'; \
1283 echo "$$diff"; exit 1;; esac; \
1284 else \
1285 : ; \
1286 fi
1287
1288 submodule-checks ?= no-submodule-changes public-submodule-commit
1289
1290 # Ensure that each sub-module commit we're using is public.
1291 # Without this, it is too easy to tag and release code that
1292 # cannot be built from a fresh clone.
1293 .PHONY: public-submodule-commit
1294 public-submodule-commit:
1295 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1296 cd $(srcdir) && \
1297 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1298 = '$$(git merge-base origin $$sha1)' \
1299 || { echo '$(ME): found non-public submodule commit' >&2; \
1300 exit 1; }; \
1301 else \
1302 : ; \
1303 fi
1304 # This rule has a high enough utility/cost ratio that it should be a
1305 # dependent of "check" by default. However, some of us do occasionally
1306 # commit a temporary change that deliberately points to a non-public
1307 # submodule commit, and want to be able to use rules like "make check".
1308 # In that case, run e.g., "make check gl_public_submodule_commit="
1309 # to disable this test.
1310 gl_public_submodule_commit ?= public-submodule-commit
1311 check: $(gl_public_submodule_commit)
1312
1313 .PHONY: alpha beta stable
1314 ALL_RECURSIVE_TARGETS += alpha beta stable
1315 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1316 test $@ = stable \
1317 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1318 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1319 || :
1320 $(MAKE) vc-diff-check
1321 $(MAKE) news-check
1322 $(MAKE) distcheck
1323 $(MAKE) dist XZ_OPT=-9ev
1324 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1325 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1326
1327 # Override this in cfg.mk if you follow different procedures.
1328 release-prep-hook ?= release-prep
1329
1330 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1331 .PHONY: release-prep
1332 release-prep:
1333 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1334 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1335 $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1336 if test -d $(release_archive_dir); then \
1337 ln $(rel-files) $(release_archive_dir); \
1338 chmod a-w $(rel-files); \
1339 fi
1340 echo $(VERSION) > $(prev_version_file)
1341 $(MAKE) update-NEWS-hash
1342 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1343 $(emit-commit-log) > .ci-msg
1344 $(VC) commit -F .ci-msg -a
1345 rm .ci-msg
1346
1347 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1348 # if the default $(PACKAGE)-derived name doesn't apply.
1349 gendocs_options_ ?=
1350
1351 .PHONY: web-manual
1352 web-manual:
1353 @test -z "$(manual_title)" \
1354 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1355 @cd '$(srcdir)/doc'; \
1356 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1357 -o '$(abs_builddir)/doc/manual' \
1358 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1359 "$(PACKAGE_NAME) - $(manual_title)"
1360 @echo " *** Upload the doc/manual directory to web-cvs."
1361
1362 # Code Coverage
1363
1364 init-coverage:
1365 $(MAKE) $(AM_MAKEFLAGS) clean
1366 lcov --directory . --zerocounters
1367
1368 COVERAGE_CCOPTS ?= "-g --coverage"
1369 COVERAGE_OUT ?= doc/coverage
1370
1371 build-coverage:
1372 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1373 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1374 mkdir -p $(COVERAGE_OUT)
1375 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1376 --capture
1377
1378 gen-coverage:
1379 genhtml --output-directory $(COVERAGE_OUT) \
1380 $(COVERAGE_OUT)/$(PACKAGE).info \
1381 --highlight --frames --legend \
1382 --title "$(PACKAGE_NAME)"
1383
1384 coverage: init-coverage build-coverage gen-coverage
1385
1386 # Update gettext files.
1387 PACKAGE ?= $(shell basename $(PWD))
1388 PO_DOMAIN ?= $(PACKAGE)
1389 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1390 PODIR ?= po
1391 refresh-po:
1392 rm -f $(PODIR)/*.po && \
1393 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1394 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1395 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1396 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1397 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1398
1399 # Running indent once is not idempotent, but running it twice is.
1400 INDENT_SOURCES ?= $(C_SOURCES)
1401 .PHONY: indent
1402 indent:
1403 indent $(INDENT_SOURCES)
1404 indent $(INDENT_SOURCES)
1405
1406 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1407 # put the assignments in this variable.
1408 update-copyright-env ?=
1409
1410 # Run this rule once per year (usually early in January)
1411 # to update all FSF copyright year lists in your project.
1412 # If you have an additional project-specific rule,
1413 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1414 # By default, exclude all variants of COPYING; you can also
1415 # add exemptions (such as ChangeLog..* for rotated change logs)
1416 # in the file .x-update-copyright.
1417 .PHONY: update-copyright
1418 update-copyright:
1419 grep -l -w Copyright \
1420 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1421 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1422
1423 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1424 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1425
1426 # NOTE: to override any _gl_TS_* default value, you must
1427 # define the variable(s) using "export" in cfg.mk.
1428 _gl_TS_dir ?= src
1429
1430 ALL_RECURSIVE_TARGETS += sc_tight_scope
1431 sc_tight_scope: tight-scope.mk
1432 @fail=0; \
1433 if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1434 > /dev/null \
1435 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1436 > /dev/null 2>&1; then \
1437 echo '$(ME): skipping $@'; \
1438 else \
1439 $(MAKE) -s -C $(_gl_TS_dir) \
1440 -f Makefile \
1441 -f $(abs_top_srcdir)/cfg.mk \
1442 -f $(abs_top_builddir)/$< \
1443 _gl_tight_scope \
1444 || fail=1; \
1445 fi; \
1446 rm -f $<; \
1447 exit $$fail
1448
1449 tight-scope.mk: $(ME)
1450 @rm -f $@ $@-t
1451 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1452 @chmod a=r $@-t && mv $@-t $@
1453
1454 ifeq (a,b)
1455 # TS-start
1456
1457 # Most functions should have static scope.
1458 # Any that don't must be marked with `extern', but `main'
1459 # and `usage' are exceptions: they're always extern, but
1460 # do not need to be marked. Symbols matching `__.*' are
1461 # reserved by the compiler, so are automatically excluded below.
1462 _gl_TS_unmarked_extern_functions ?= main usage
1463 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1464
1465 # If your project uses a macro like "XTERN", then put
1466 # the following in cfg.mk to override this default:
1467 # export _gl_TS_extern = extern|XTERN
1468 _gl_TS_extern ?= extern
1469
1470 # The second nm|grep checks for file-scope variables with `extern' scope.
1471 # Without gnulib's progname module, you might put program_name here.
1472 # Symbols matching `__.*' are reserved by the compiler,
1473 # so are automatically excluded below.
1474 _gl_TS_unmarked_extern_vars ?=
1475
1476 # NOTE: the _match variables are perl expressions -- not mere regular
1477 # expressions -- so that you can extend them to match other patterns
1478 # and easily extract matched variable names.
1479 # For example, if your project declares some global variables via
1480 # a macro like this: GLOBAL(type, var_name, initializer), then you
1481 # can override this definition to automatically extract those names:
1482 # export _gl_TS_var_match = \
1483 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1484 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1485
1486 # The names of object files in (or relative to) $(_gl_TS_dir).
1487 _gl_TS_obj_files ?= *.$(OBJEXT)
1488
1489 # Files in which to search for the one-line style extern declarations.
1490 # $(_gl_TS_dir)-relative.
1491 _gl_TS_headers ?= $(noinst_HEADERS)
1492
1493 .PHONY: _gl_tight_scope
1494 _gl_tight_scope: $(bin_PROGRAMS)
1495 t=exceptions-$$$$; \
1496 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1497 for sig in 1 2 3 13 15; do \
1498 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1499 done; \
1500 src=`for f in $(SOURCES); do \
1501 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1502 hdr=`for f in $(_gl_TS_headers); do \
1503 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1504 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1505 grep -h -A1 '^extern .*[^;]$$' $$src \
1506 | grep -vE '^(extern |--)' | sed 's/ .*//'; \
1507 perl -lne \
1508 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1509 ) | sort -u > $$t; \
1510 nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1511 && { echo the above functions should have static scope >&2; \
1512 exit 1; } || : ; \
1513 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
1514 perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1515 ) | sort -u > $$t; \
1516 nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
1517 | sort -u | grep -Ev -f $$t \
1518 && { echo the above variables should have static scope >&2; \
1519 exit 1; } || :
1520 # TS-end
1521 endif